#ifndef __MMANAGER_H__
#define __MMANAGER_H__

#include <list>
#include <windows.h>

class CMMObject;




//------------------------------------------------------------
// CMManager klasa - sluzi za rad sa objektima u memoriji
//------------------------------------------------------------
class CMManager
{
private:
	std::list<CMMObject*> Objects;
public:
	std::list<CMMObject*>::iterator AddObject( CMMObject* obj );
	void RemoveObject( std::list<CMMObject*>::iterator it );
	template <typename T>
	BOOL FindObjectByName( LPCSTR name, T obj, BOOL createnew );
};




//------------------------------------------------------------
// CMMObject klasa - svi objekti nasledjuju ovu klasu
//------------------------------------------------------------
class CMMObject
{
private:
	static CMManager* MemoryManager;
	long refCount;
	LPSTR Name;
	std::list<CMMObject*>::iterator It;
	HRESULT AllocateName( LPCSTR name, LPSTR *newname );
public:
	CMMObject( LPSTR name );
	virtual ~CMMObject();
	void AddRef();
	void Release();
};

#endif //#ifndef __MMANAGER_H__